```@meta
CurrentModule = QuantumControlBase
```

# QuantumControlBase

The [QuantumControlBase](https://github.com/JuliaQuantumControl/QuantumControlBase.jl) package provides methods the are useful to multiple packages within the [JuliaQuantumControl](https://github.com/juliaquantumcontrol) organization.

!!! note

    All user-facing methods defined here are exposed in the main [QuantumControl](https://juliaquantumcontrol.github.io/QuantumControl.jl/) package, so please see [its documentation](https://juliaquantumcontrol.github.io/QuantumControl.jl/) for information on the usage of these methods in a larger context.


## Contents

```@contents
Pages = ["index.md"]
Depth = 3
```

``\gdef\tgt{\text{tgt}}``
``\gdef\tr{\operatorname{tr}}``
``\gdef\Re{\operatorname{Re}}``
``\gdef\Im{\operatorname{Im}}``


## `QuantumControlBase` Module

#### public members

```@autodocs
Modules = [QuantumControlBase]
Private = false
```

#### private members

```@autodocs
Modules = [QuantumControlBase]
Public = false
```


### `Shapes` Sub-Module

```@autodocs
Modules = [QuantumControlBase.Shapes]
```

### `Functionals` Sub-Module

#### public members

```@autodocs
Modules = [QuantumControlBase.Functionals]
Private = false
```

#### private members

```@autodocs
Modules = [QuantumControlBase.Functionals]
Public = false
```

### `WeylChamber` Sub-Module

```@autodocs
Modules = [QuantumControlBase.WeylChamber]
```

### `ConditionalThreads` Sub-Module

!!! note

    This module is not re-exported in the `QuantumControl` package


```@autodocs
Modules = [QuantumControlBase.ConditionalThreads]
```

### `TestUtils` Sub-Module

!!! warning

    This module is not re-exported in the `QuantumControl` package. Moreover, it is not considered part of the public API and may change in any point release.

```@autodocs
Modules = [QuantumControlBase.TestUtils]
```


## Index

```@index
Pages = ["index.md"]
```
